#include <tonc.h>
#include "include/sprRaw.h"
#include "include/objLink.h"

OBJ_ATTR sprite_list[128];
int sprite_count = 0;

ObjLink Link;

int main(){
  irq_init(NULL);
  irq_add(II_VBLANK,NULL);
  oam_init(sprite_list,128);
  
  REG_DISPCNT = DCNT_OBJ | DCNT_OBJ_1D;
  memcpy16(pal_obj_mem,sprDefaultPal,256);
  memcpy32(tile_mem[4],sprShadowTiles,16);
  
  Link_Create(&Link,120,64,0,270);
  
  while (TRUE){
    VBlankIntrWait();
    key_poll();
    oam_init(sprite_list,sprite_count);
    sprite_count = 0;
    Link_Step(&Link);
    Link_Draw(&Link);
    oam_copy(oam_mem,sprite_list,sprite_count);
  }
  
  return 0;
}