#include "include/object.h"

void Object_Create(Object *obj,int x,int y,int pal,int dir){
  obj->palette_index = pal;
  obj->sprite_index = -1;
  obj->image_index = 0;
  obj->image_speed = 0;
  obj->direction = dir;
  obj->x = x << 8; obj->y = y << 8;
  obj->stepX = 0; obj->stepY = 0;
  obj->moveX = 0; obj->stepY = 0;
  obj->maxiX = 0; obj->maxiY = 0;
  obj->keyL = 0;
  obj->keyR = 0;
  obj->keyU = 0;
  obj->keyD = 0;
}

void direction_set(Object *obj){
  if ((obj->keyL || obj->keyR) && (obj->keyU || obj->keyD)){
    if (obj->keyU && obj->direction == 270)
      obj->direction = 90;
    else if (obj->keyD && obj->direction == 90)
      obj->direction = 270;
    else if (obj->keyL && obj->direction == 0)
      obj->direction = 180;
    else if (obj->keyR && obj->direction == 180)
      obj->direction = 0;
  }
  else if (obj->keyU) 
    obj->direction = 90;
  else if (obj->keyD)
    obj->direction = 270;
  else if (obj->keyL)
    obj->direction = 180;
  else if (obj->keyR)
    obj->direction = 0;
}